#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include <errno.h>
#include "netfd.h"

#define	DEF_ADDR	"192.168.1.23"
#define	DEF_PORT	"31415"
#define	DEF_BACKLOG	(2)

static void	daytime(netfd_t *);

static void
daytime(nfd)
	netfd_t *	nfd;
{
  time_t	ticks = time(NULL);
  char		buf[256];

  memset(buf, 0, sizeof(buf));
  snprintf(buf, sizeof(buf), "%.24s\r\n", ctime(&ticks));
  netfd_write(nfd, buf, strlen(buf), NETFD_NO_TIMEOUT);
  netfd_close(nfd);
}

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  if (netfd_init(0) == 0) {
    netfd_t *	nsd;

    nsd = netfd_tcp_server(DEF_ADDR, DEF_PORT, DEF_BACKLOG);
    if (nsd != NULL) {
      fprintf(stderr, "DEBUG: %s:%s\n", DEF_ADDR, DEF_PORT);
      netfd_read_event_add(nsd);
      netfd_dispatch(daytime, true, -1);
      netfd_close(nsd);
    }
  }

  return 0;
}
