#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/event.h>
#include <sys/time.h>
#include <time.h>
#include <netdb.h>
#include <errno.h>
#include "netfd.h"

#define	DEF_ADDR	"192.168.1.23"
#define	DEF_PORT	"27182"
#define	DEF_BACKLOG	(2)

static void	echo(netfd_t *);
static void	info(netfd_t *);

static void
echo(nfd)
	netfd_t *	nfd;
{
  char		buf[BUFSIZ];
  ssize_t	n;

  info(nfd);
  memset(buf, 0, sizeof(buf));
  n = netfd_readline(nfd, buf, sizeof(buf), NETFD_NO_TIMEOUT);
  if (n > 0) {
    fprintf(stderr, "DEBUG[echo] %s", buf);
    netfd_write(nfd, buf, strlen(buf), NETFD_NO_TIMEOUT);
  }
  if (strncmp(buf, "quit", 4) == 0) {
    netfd_close(nfd);
  }
}

static void
info(nfd)
	netfd_t *	nfd;
{
  char	host[NI_MAXHOST];
  char	serv[NI_MAXSERV];

  if (netfd_getnameinfo(nfd, host, sizeof(host), serv, sizeof(serv)) == 0) {
    fprintf(stderr, "DEBUG[info] %s:%s\n", host, serv);
  }
}

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  if (netfd_init(0) == 0) {
    netfd_t *	nsd;

    nsd = netfd_tcp_server(DEF_ADDR, DEF_PORT, DEF_BACKLOG);
    if (nsd != NULL) {
      fprintf(stderr, "DEBUG: %s:%s\n", DEF_ADDR, DEF_PORT);
      netfd_read_event_add(nsd);
      netfd_dispatch(echo, false, -1);
      netfd_close(nsd);
    }
  }

  return 0;
}
